/**********************************************************************
  sim CLOCK (Pseudo Clock device)
  $Id: dev_clock.c,v 1.2 2002/11/03 03:57:34 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"
#include "sim_io.h"

#define reverse_uint(a)   { *a=((*a<<24)&0xff000000)|((*a<<8)&0x00ff0000)|((*a>>8)&0x0000ff00)|((*a>>24)&0x000000ff); }

int dev_clock( unsigned int port , struct MACHINE_RESOURCE *mres )
{
  int cmd ;
  int ret_code ;
  
  ret_code = NORMAL_EXIT ;
  
  /** access CLOCK device **/
  cmd  = mres->mem[seg(CLOCK_READ_CMD+3)][lad(CLOCK_READ_CMD+3)] ;
  if( cmd != 0 ){
    if( time( (time_t*)&mres->mem[seg(CLOCK_DATA)][lad(CLOCK_DATA)] ) != -1 ){
      ret_code=-1 ;
    }else{
      reverse_uint( (unsigned int*)&mres->mem[seg(CLOCK_DATA+ 0)][lad(CLOCK_DATA+ 0)] ) ;
    }
    mres->mem[seg(CLOCK_READ_CMD+3)][lad(CLOCK_READ_CMD+3)]=0 ;
  }

  return( ret_code ) ;
}


int dev_clock_init( struct MACHINE_RESOURCE *mres )
{
  return( NORMAL_EXIT ) ;
}
