/**********************************************************************
  psR}h
  $Id: ps_cmd.c,v 1.5 2003/07/06 01:37:04 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int  ps_parse_opt(struct GETOPT_ARG *args) ;
void ps_print_help() ;

int ps_cmd( struct GETOPT_ARG *args , int mode )
{
  int i ;
  int ret ;
  
  ret=ps_parse_opt(args) ;
  if( ret<0 ) return(NORMAL_EXIT) ;
  
  SYSMSG("ID         size   name\n") ;
  for( i=0 ; i<= proc_list.cur_id ; i++ ){
    SYSMSG("%2d   %10d   %s\n",i,proc_list.proc[i].mem_size[0],proc_list.proc[i].pname) ;
  }
  return(NORMAL_EXIT) ;
}


int ps_parse_opt(struct GETOPT_ARG *args)
{
  static struct GETOPT_LIST getopt_list[]={
    {"help",               'h',  NONARG, 'h'},
    { NULL,               '\0',       0,'\0'} /*** terminator ***/
  } ;
  int ret ;
  
  while(-1){
    ret=xgetopt(args, getopt_list) ;
    if( ret==XGETOPT_PARSE_COMPLETE ) break ;
    switch(ret){
    case 'h' :
      ps_print_help() ;
      return(-1) ;
      break ;
    case XGETOPT_INVALID_OPTION :
      SYSERR("Invalid option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_ARG_NOT_FOUND :
      SYSERR("Illegal arg for option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_NOT_OPTION :
      break ;
    default :
      SYSERR("xgetopt internal error\n") ;
      return(-1) ;
    }
  }
  return(0) ;
}


void ps_print_help()
{
  SYSERR(
	 "Print process list\n"
	 "Usage: ps [Options]\n"
	 " Options\n"
	 "  -h or --help : Print this help.\n"
	 "\n"
	 "     ݑ݂̃vZẌꗗ\\܂B\n"
	 ) ;
}
