/**********************************************************************
  g[XqXg[_v
  $Id: td_cmd.c,v 1.7 2003/07/06 01:37:05 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

struct TD_STATE{
  int mode ;
} ;

#define DISP_PC   0
#define DISP_DIS  1
#define BUFSIZE  16

int  td_parse_opt(struct GETOPT_ARG *args,struct TD_STATE *td_stat) ;
void td_print_help() ;

int td_cmd( struct GETOPT_ARG *args , int mode )
{
  static int first=1 ;
  int j,k ;
  int tp ;
  int pc_cur, pc_prv, pc_dist ;
  unsigned char pcbuf_cur[BUFSIZE]  ;
  unsigned char pcbuf_prv[BUFSIZE]  ;
  unsigned char pcbuf[BUFSIZE]  ;
  struct MACHINE_RESOURCE tmp_proc ;
  struct TD_STATE td_stat ;
  int ret ;
  
  ret=td_parse_opt(args,&td_stat) ;
  if( ret<0 ) return(NORMAL_EXIT) ;
  
  pcbuf_cur[0]='\0' ; pcbuf_prv[0]='\0' ; pcbuf[0]='\0' ;
  pc_dist=0 ; pc_prv=0 ;

  if( first==1 ){
    init_regs( &tmp_proc ) ;
    for( j=0 ; j<MEM_SEGMENT_NUM ; j++ ){
      tmp_proc.mem[j]=NULL ;
      tmp_proc.mem_size[j]=0 ;
      tmp_proc.mem_attr[j]=MEM_ATTR_NORMAL ;
    }
    first=0 ;
  }
  ret=memal( &tmp_proc, 0, 16, MEM_ATTR_NORMAL) ;
  if( ret!=NORMAL_EXIT ){
    return(MEM_ALLOC_ERROR) ;
  }
  
  tp=trace.ptr ;
  if( td_stat.mode==DISP_DIS ){
    SYSMSG("PID : PC       : Instruction\n") ;
  }
  for( j=0 ; j<trace.size ; j++ ){
    pc_cur=trace.buf[tp].pc ;
    if( trace.buf[tp].pid>=0 ){
      if( td_stat.mode==DISP_DIS ){
	unsigned char *p ;
	p=tmp_proc.mem[0] ;
	p[0]=(trace.buf[tp].inst & 0xff000000)>>24 ;
	p[1]=(trace.buf[tp].inst & 0x00ff0000)>>16 ;
	p[2]=(trace.buf[tp].inst & 0x0000ff00)>>8  ;
	p[3]=(trace.buf[tp].inst & 0x000000ff)     ;
	tmp_proc.pc=0 ;
	SYSMSG("%3d : %08x : ",trace.buf[tp].pid,trace.buf[tp].pc) ;
	op_exec(&tmp_proc,EXEC_DIS) ;
      }else{
	sprintf(pcbuf_cur,"%08x",pc_cur) ;
	if( tp==trace.ptr ){
	  pc_prv=pc_cur ;
	  strcpy(pcbuf_prv,pcbuf_cur) ;
	  strcpy(pcbuf    ,pcbuf_cur) ;
	}else{
	  pc_dist+=4 ;
	  if( pc_cur!=(pc_prv+pc_dist) ){
	    pc_prv=pc_cur ;
	    pc_dist=0 ;
	    strcpy(pcbuf_prv,pcbuf_cur) ;
	    strcpy(pcbuf    ,pcbuf_cur) ;
	  }else{
	    for( k=0 ; k<BUFSIZE ; k++ ){
	      if( pcbuf_prv[k]=='\0' ) break ;
	      if( pcbuf_cur[k]==pcbuf_prv[k] ){
		pcbuf[k]='_' ;
	      }else{
		strcpy(&pcbuf[k],&pcbuf_cur[k]) ;
		break ;
	      }
	    }
	  }
	}
	
	SYSMSG("%s(%08x)->",pcbuf,trace.buf[tp].inst) ;
	if( j%4==3 ){
	  SYSMSG("\n") ;
	}
      }
    }
    tp=(tp+1)%trace.size ;
  }
  SYSMSG("Number of executed instructions=") ;
  SYSMSGLL(iexe_count,0) ;
  SYSMSG("\n") ;
    
  return(NORMAL_EXIT) ;
}


int td_parse_opt(struct GETOPT_ARG *args,struct TD_STATE *td_stat)
{
  static struct GETOPT_LIST getopt_list[]={
    {"dis",                'd',  NONARG, 'd'},
    {"help",               'h',  NONARG, 'h'},
    { NULL,               '\0',       0,'\0'} /*** terminator ***/
  } ;
  int ret ;

  td_stat->mode=DISP_PC ;
  
  while(-1){
    ret=xgetopt(args, getopt_list) ;
    if( ret==XGETOPT_PARSE_COMPLETE ) break ;
    switch(ret){
    case 'h' :
      td_print_help() ;
      return(-1) ;
      break ;
    case 'd' :
      td_stat->mode=DISP_DIS ;
      break ;
    case XGETOPT_INVALID_OPTION :
      SYSERR("Invalid option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_ARG_NOT_FOUND :
      SYSERR("Illegal arg for option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_NOT_OPTION :
      break ;
    default :
      SYSERR("xgetopt internal error\n") ;
      return(-1) ;
    }
  }
  return(0) ;
}


void td_print_help()
{
  SYSERR(
	 "Print trace history dump\n"
	 "Usage: td [Options]\n"
	 " Options\n"
	 "  -d or --dis  : Print disassemble.\n"
	 "  -h or --help : Print this help.\n"
	 "\n"
	 "     g[X_v\\܂B݂pc̒lߋ%d̎s߂\n"
	 "    pc16iߗ\\܂B܂Aset pc s_猻݂܂ł\n"
	 "    sꂽߐ̕\\s܂B\n"
	 ,DEFAULT_TRACE_SIZE
	 ) ;
}
