/**********************************************************************
  trussCNR}h
  scߎs̏\̃tO𐧌䂷
  $Id: truss_cmd.c,v 1.4 2003/07/06 01:37:06 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int  truss_parse_opt(struct GETOPT_ARG *args) ;
void truss_print_help() ;

int truss_cmd( struct GETOPT_ARG *args, int mode )
{
  int ret ;

  ret=truss_parse_opt(args) ;
  if( ret<0 ) return(NORMAL_EXIT) ;
  
  if( XGETOPT_REFARGP(args,1)==NULL ){
    SYSMSG("Current truss state=%s\n",truss_stat==ON ? "ON" : "OFF" ) ;
    return(NORMAL_EXIT) ;
  }
  if( strcmp(XGETOPT_REFARGP(args,1),"on")==0 ){
    truss_stat=ON ;
  }else if( strcmp(XGETOPT_REFARGP(args,1),"off")==0 ){
    truss_stat=OFF ;
  }else{
    SYSMSG("Invalid argument %s\n",XGETOPT_REFARGP(args,1) ) ;
  }
  
  return(NORMAL_EXIT) ;
}


int truss_parse_opt(struct GETOPT_ARG *args)
{
  static struct GETOPT_LIST getopt_list[]={
    {"help",               'h',  NONARG, 'h'},
    { NULL,               '\0',       0,'\0'} /*** terminator ***/
  } ;
  int ret ;
  
  while(-1){
    ret=xgetopt(args, getopt_list) ;
    if( ret==XGETOPT_PARSE_COMPLETE ) break ;
    switch(ret){
    case 'h' :
      truss_print_help() ;
      return(-1) ;
      break ;
    case XGETOPT_INVALID_OPTION :
      SYSERR("Invalid option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_ARG_NOT_FOUND :
      SYSERR("Illegal arg for option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_NOT_OPTION :
      break ;
    default :
      SYSERR("xgetopt internal error\n") ;
      return(-1) ;
    }
  }
  return(0) ;
}


void truss_print_help()
{
  SYSERR(
	 "Trace system calls\n"
	 "Usage: truss [Options] [on|off]\n"
	 "  on   : Trace ON.\n"
	 "  off  : Trace OFF.\n"
	 " Options\n"
	 "  -h or --help : Print this help.\n"
	 "\n"
	 "     sc߂sAVXeR[G~[gꂽAVXeR[\n"
	 "    ɓnꂽȂǂ\\܂B\n"
	 "    ppcsim̏Nɂ truss off ̏ԂłAsc߂sĂb\n"
	 "    Z[W̕\\͍s܂B\\sꍇ́AgoR}h\n"
	 "    execR}h̎sO truss on sĉB\n"
	 "\n"
	 "    ȗꍇ݂͌̏oON/OFF̂̏Ԃ\\܂B\n"
	 ) ;
}
  
