/**********************************************************************
  get option 
  $Id: xgetopt.c,v 1.1 2003/07/06 01:37:06 tane Exp $
**********************************************************************/
#include <stdlib.h>
#include <stdio.h> 
#include <strings.h> 
#include "strbuf.h"
#include "xgetopt.h"

#define ERR_STRLEN 255

int xgetopt( struct GETOPT_ARG *args, struct GETOPT_LIST *list )
{
  static int firstcall=1 ;
  static int curpt ;
  static int charpt ;
  int find ;
  int i,j ;

  if( firstcall==1 ){
    firstcall=0 ;
    xgetopt_val=NULL ;
    xgetopt_str=NULL ;
    xgetopt_err=NULL ;
  }
  
  if( args->flag==0 ){
    args->flag=1 ;
    curpt=0 ;
    charpt=0 ;
  }

  while( -1 ){
    unsigned char *tmpp ;
    
    if( xgetopt_str!=NULL ){
      free(xgetopt_str) ;
      xgetopt_str=NULL ;
    }

    tmpp=STR_refstr(args->sb,curpt) ;
    if( tmpp==NULL ) return( XGETOPT_PARSE_COMPLETE ) ;

    xgetopt_str=malloc(strlen(tmpp)+1) ;
    strcpy(xgetopt_str,tmpp) ;

    if( xgetopt_str[0]=='-' ){
      if( xgetopt_str[1]=='-' ){ /** long name option **/
	j=0 ;
	for( i=0,find=0 ; ; i++ ){
	  if( list[i].name==NULL && list[i].ch=='\0' ) break ;
	  if( list[i].name[0]=='\0' ) continue ;
	  for( j=0 ; ; j++ ){
	    if( xgetopt_str[2+j]==list[i].name[j] ){
	      if( list[i].name[j]=='\0' && xgetopt_str[2+j]=='\0' ){
		if( list[i].flag==NONARG ) find=1 ;
		break ;
	      }
	      if( list[i].flag==NEEDARG &&
		  xgetopt_str[2+j+1]=='=' && list[i].name[j+1]=='\0' ){
		j++ ;
		find=1 ;
		break ;
	      }
	    }else{
	      break ;
	    }
	  }
	  if( find==1 ) break ;
	}
	if( find!=0 ){
	  if( list[i].flag==NONARG ){
	    STR_dellist(args->sb,curpt) ;
	  }else{
	    unsigned char *st ;
	    if( xgetopt_val!=NULL ){
	      free(xgetopt_val) ;
	      xgetopt_val=NULL ;
	    }
	    st=&xgetopt_str[2+j+1] ;
	    if( st[0]!='\0' ){
	      xgetopt_val=malloc( strlen(st)+1 ) ;
	      if( xgetopt_val==NULL ) return(XGETOPT_MALLOC_ERROR) ;
	      strcpy(xgetopt_val,st) ;
	    }else{
	      if( xgetopt_err!=NULL ){
		free(xgetopt_err) ;
		xgetopt_err=NULL ;
	      }
	      xgetopt_err=malloc(ERR_STRLEN+1) ;
	      snprintf(xgetopt_err,ERR_STRLEN,"%s",xgetopt_str) ;
	      return(XGETOPT_ARG_NOT_FOUND) ;
	    }
	    STR_dellist(args->sb,curpt) ;
	  }
	  return( list[i].ret ) ;
	}else{
	  if( xgetopt_err!=NULL ){
	    free(xgetopt_err) ;
	    xgetopt_err=NULL ;
	  }
	  xgetopt_err=malloc(ERR_STRLEN+1) ;
	  snprintf(xgetopt_err,ERR_STRLEN,"%s",xgetopt_str) ;
	  return(XGETOPT_INVALID_OPTION) ;
	}
      }else{
	find=0 ;
	if( xgetopt_str[1+charpt]=='\0' ){
	  charpt=0 ;
	  STR_dellist(args->sb,curpt) ;
	  continue ;
	}else{
	  for( i=0 ; ; i++ ){
	    if( list[i].name==NULL && list[i].ch=='\0' ) break ;
	    if( list[i].ch=='\0' ) continue ;
	    if( xgetopt_str[1+charpt]==list[i].ch ){
	      find=1 ;
	      break ;
	    }
	  }
	  if( find!=0 ){
	    if( list[i].flag==NEEDARG ){
	      unsigned char *st ;
	      STR_dellist(args->sb,curpt) ;
	      if( xgetopt_val!=NULL ){
		free(xgetopt_val) ;
		xgetopt_val=NULL ;
	      }
	      st=STR_refstr(args->sb,curpt) ;
	      if( st!=NULL ){
		charpt=0 ;
		xgetopt_val=malloc( strlen(st)+1 ) ;
		if( xgetopt==NULL ) return(XGETOPT_MALLOC_ERROR) ;
		strcpy(xgetopt_val,st) ;
		STR_dellist(args->sb,curpt) ;
	      }else{
		if( xgetopt_err!=NULL ){
		  free(xgetopt_err) ;
		  xgetopt_err=NULL ;
		}
		xgetopt_err=malloc(ERR_STRLEN+1) ;
		snprintf(xgetopt_err,ERR_STRLEN,"-%1c",xgetopt_str[1+charpt]) ;
		charpt=0 ;
		return(XGETOPT_ARG_NOT_FOUND) ;
	      }
	      charpt=0 ;
	    }else{
	      charpt++ ;
	    }
	    return( list[i].ret ) ;
	  }else{
	    if( xgetopt_err!=NULL ){
	      free(xgetopt_err) ;
	      xgetopt_err=NULL ;
	    }
	    xgetopt_err=malloc(ERR_STRLEN+1) ;
	    snprintf(xgetopt_err,ERR_STRLEN,"-%1c",xgetopt_str[1+charpt]) ;
	    charpt++ ;
	    return(XGETOPT_INVALID_OPTION) ;
	  }
	}
      }
    }else{
      curpt++ ;
      return(XGETOPT_NOT_OPTION) ;
    }
  }
}

#ifdef XGETOPT_TEST

int main(int argc,char *argv[])
{
  struct GETOPT_ARG args ;
  static struct GETOPT_LIST getopt_list[]={
    {"long-name-1",  '1',  NONARG, '1'},
    {"long-name-2",  '2', NEEDARG, '2'},
    {"long-name-3",  '3',  NONARG, '3'},
    {"long-name-4",  '4', NEEDARG, '4'},
    { NULL,         '\0',       0, '0'} /*** terminator ***/
  } ;
  int i ;
  int ret ;

  XGETOPT_INIARG(args) ;

  for( i=1 ; i<argc ; i++ ){
    XGETOPT_ADDARG(args,argv[i]) ;
  }

  while(-1){
    ret=xgetopt(&args, getopt_list) ;
    if( ret==XGETOPT_PARSE_COMPLETE ) break ;
    switch(ret){
    case '1' :
      printf("long-name-1\n") ;
      break ;
    case '2' :
      printf("long-name-2 %s\n",xgetopt_val) ;
      break ;
    case '3' :
      printf("long-name-3\n") ;
      break ;
    case '4' :
      printf("long-name-4 %s",xgetopt_val) ;
      break ;
    case XGETOPT_INVALID_OPTION :
      printf("invalid option %s\n",xgetopt_err) ;
      break ;
    case XGETOPT_ARG_NOT_FOUND :
      printf("illegal arg for option %s\n",xgetopt_err) ;
      break ;
    case XGETOPT_NOT_OPTION :
      printf("not option %s\n",xgetopt_str) ;
      break ;
    default :
      printf("xgetopt internal error\n") ;
      exit(-1) ;
    }
    if( ret<-1 ) break ;
  }

  for( i=0 ; ; i++ ){
    if( XGETOPT_REFARG(args,i)==NULL ) break ;
  }
  
  XGETOPT_FREARG(args) ;

  exit(0) ;
}

#endif

